import collections
import socket

class Socket:
	__slots__ = ["sock", "buf", "stat", "type"]
	
	def __init__(self): self.sock = None; self.buf = ""; self.stat=collections.defaultdict(int); self.type = "X"
	
	def create(self, sock): self.sock = sock; self.buf = ""; self.type = "S"
	
	def listen(self, port):
		try:
			self.type = "L"
			self.sock = socket.socket(socket.AF_INET)
			self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
			self.sock.bind(('',port))
			self.sock.listen(10)
		except: raise Exception("Napaka pri cakanju na povezave")
	
	def accept(self):
		try:
			s = Socket()
			s.create(self.sock.accept()[0])
			s.writeline("KPS server v.0.1py")
			ime = s.readline()
			s.writeline('PRIJAVA USPESNA')
			return (s, ime[4:])
		except: raise Exception("Napaka pri sprejemanju povezave")
	
	def connect(self, hostName, port, ime):
		try:
			self.type = "C"
			self.sock = socket.socket(socket.AF_INET)
			self.sock.connect((hostName, port))
		except: raise Exception("Prijava na streznik neuspesna")
		self.buf = ""
		server = self.readline()
		print "%s" % server
		self.writeline("AVE %s" % (ime))
		succ = self.readline()
		if succ != "PRIJAVA USPESNA": raise Exception("Prijava na streznik neuspesna: %s" % succ)
	
	def close(self):
		if self.sock: self.sock.close()
	
	def readline(self):
		while True:
			i = self.buf.find('\n')
			if i >= 0: 
				line = self.buf[:i].strip()
				self.buf = self.buf[i + 1:]
				return line
			try: s = self.sock.recv(1024)
			except: raise IOError("Napaka v komunikaciji")
			if not s: raise IOError("%s je zaprl povezavo" % ("Streznik" if self.type=="C" else "Tekmovalec"))
			self.buf += s
	
	def readvector(self):
		r =  self.readline().split()
		#print r
		return r
	
	def readexpect(self, cmd):
		v = self.readvector()
		if v[0] == cmd:
			return v[1:]
		else:
			raise Exception("Sprejel napacen odgovor")
			
	def writeline(self, line):
		#print line
		self.sock.send(line + "\n")
	
	def igraj(self, t_jaz, t_nasprotnik, prev_jaz, prev_nasprotnik):
		self.writeline(('IGRAJ %d %d %s %s' % (t_jaz, t_nasprotnik, prev_jaz, prev_nasprotnik)))
	
	def adijo(self):
		self.writeline('ADIJO')
