#!/usr/bin/env python

import sys, math, traceback, random, copy, pickle, time
import traceback, getopt
import subprocess
import itertools

from common import *

def premaga(a,b):
    pravila = [('K', 'S'), ('S', 'P'), ('P', 'K')]
    if a==b: return [1,1]
    elif (a,b) in pravila: return [2,0]
    elif (b,a) in pravila: return [0,2]
    else: raise Exception("napacna pravila")

def run_game(c, t, p):
    c[0][0].igraj(t[0], t[1], p[0], p[1])
    c[1][0].igraj(t[1], t[0], p[1], p[0])

    n = ['X', 'X']
    n[0] = c[0][0].readexpect("IGRAM")[0]
    n[1] = c[1][0].readexpect("IGRAM")[0]

    assert(n[0] in ('K', 'P', 'S'))
    assert(n[1] in ('K', 'P', 'S'))

    tocke = premaga(*n)
    return tocke, n

def main(stIger, randomSeed, logIgre=[], clientProgs=[]):
	"""
	Zazene streznik, nato pa se vse kliente, ki so navedeni v <clientProgs>
	(z executable filenameom). Pocaka, da se povezejo vsi klienti, nato
	odigra <stIger> iger.
	"""
	print "Cakam na vse igralce..."
	
	print 'PRNG seme =', randomSeed
	
	ls = Socket()
	ls.listen(1180)
	
	clientOuts = [open("stdout_client%d.txt" % i, "w") for i in range(1,len(clientProgs)+1)]
	for clientProg, clientOut in zip(clientProgs, clientOuts):
		if clientProg.split()[0].endswith(".py"):
			clientProg = "python.exe " + clientProg
		subprocess.Popen(clientProg, stdout=clientOut, stderr=clientOut)
	
	clients = []
	for i in range(2):
		clients.append(ls.accept())
		print '  ... povezal se je igralec "%s".' % clients[-1][1]
        #print clients

	logFile = None
	if not logIgre==[]:
		logFile = open(logIgre[0], 'w')
		#logFile.write(','.join([''] + [c[1] for c in clients]) + '\n')
	
	tocke = [0, 0]
        pp = ['X', 'X']
	for i in xrange(stIger):
		try:
			trenutne_tocke, pp = run_game(clients, tocke, pp)
			tocke = map(lambda x,y:x+y, tocke, trenutne_tocke)
			
                        #print ' '.join([str(t) for t in trenutne_tocke])
                        print '%s:%s:%d %s:%s:%d' % (clients[0][1], pp[0], trenutne_tocke[0], clients[1][1], pp[1], trenutne_tocke[1])
			if logFile:
				#logFile.write(','.join([str(t) for t in trenutne_tocke]) + '\n')
                            logFile.write('%s,%s,%d,%s,%s,%d\n' % (clients[0][1], pp[0], trenutne_tocke[0], clients[1][1], pp[1], trenutne_tocke[1]))
                            logFile.flush()
		except IOError:
			print 'Igra prekinjena zaradi I/O napake:'
			traceback.print_exc()
			break

        print "tocke: %s:%d, %s:%d" % (clients[0][1], tocke[0], clients[1][1], tocke[1])

	try: [c[0].adijo() for c in clients]
	except: pass
	
	if logFile: logFile.close()

	for clientOut in clientOuts:
		clientOut.flush() # naj raje OS dokoncno zapre fajle

CMDLINE_HELP = """
Sintaksa:
  python tarok_eval_cli.py -n <SteviloIger> [-c <clientExe>] [-c <clientExe2>]

Parametri:
  -n <SteviloIger> -- Stevilo iger, ki naj jih odigrajo igralci
  -c <clientExe> -- Argument te oblike se lahko pojavi veckrat. Za vsako
      od pojavitev streznik na lokalnem racunalniku zazene navedenega clienta
      in ga poveze nase.
  -l <logFile> -- Logira rezultate vseh iger v podani CSV file.
  -s <seme> -- Seme za PRNG [sicer trenutni cas]
"""

if __name__ == "__main__":
	print "Kamen-Papir-Skarje testni streznik"

        stIger = 1000
	try:
		opts, unparsed = getopt.getopt(sys.argv[1:], "n:c:l:s:")
		assert unparsed==[], "Unknown option(s): "+', '.join(unparsed)
		clients = [o[1] for o in opts if o[0]=='-c']
		stIger = int([o[1] for o in opts if o[0]=='-n'][0])
		logIgre = [o[1] for o in opts if o[0]=='-l'][:1]
		try:
			randomSeed = int([o[1] for o in opts if o[0]=='-s'][0])
		except:
			randomSeed = time.time()
	except:	
		print CMDLINE_HELP
		#traceback.print_exc()
		sys.exit(1)

	main(stIger, randomSeed, logIgre, clients)
